####################################################################################
# Copyright (C) 2019                                                               #
# TETCOS, Bangalore. India                                                         #
#                                                                                  #
# Tetcos owns the intellectual property rights in the Product and its content.     #
# The copying, redistribution, reselling or publication of any or all of the       #
# Product or its content without express prior written consent of Tetcos is        #
# prohibited. Ownership and / or any other right relating to the software and all  #
# intellectual property rights therein shall remain at all times with Tetcos.      #
#                                                                                  #
# Author:    Dilip Kumar Kundrapu                                                  #
# Date:      16-01-2019                                                            #
#                                                                                  #
# ---------------------------------------------------------------------------------#

# An example script to send client request to NetSim server using socket programming in Python
import socket # for socket
import sys
import time
from mfrProtocol import*


#-----------------------Functions------------------------
def _ipaddr(a):
    if a == 'WIRELESS_NODE_1':
        return '11.1.1.1'
    if a == 'WIRELESS_NODE_2':
        return '11.1.1.2'
    if a == 'WIRELESS_NODE_3':
        return '11.1.1.3'
    if a == 'WIRELESS_NODE_4':
        return '11.1.1.4'
    if a == 'WIRELESS_NODE_5':
        return '11.1.1.5'
    if a == 'WIRELESS_NODE_6':
        return '11.1.1.6'


#----------------------Socket code-----------------------
for each in range(0, len(route)-1):

    try:
        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        print ("Socket successfully created.")
    except socket.error as err:
    	print ("Socket creation failed with error %s" %(err))

    # default port for socket
    port = 8999

    try:
    	host_ip = socket.gethostbyname('127.0.0.1')
    except socket.gaierror:
    	# this means could not resolve the host
    	print ("Error resolving host.")
    	sys.exit()

    # connecting to the server
    s.connect((host_ip, port))
    print ("Connection established to NetSim.")

    #print ('each = ', each)

    name = route[each]
    name = name + '\0'
    s.send(name.encode())

    command = 'route ADD 11.1.1.6 MASK 255.255.255.255 ' + _ipaddr(route[each+1]) + ' METRIC 1 IF 1'
    command = command + '\0'
    #print ('static for ', route[each].decode('utf-8'), '=', command.decode('utf-8'))
    s.send(command.encode())

    resp = s.recv(1024).decode('utf-8')
    cont = '__continue__'
    while cont not in resp:
        resp = resp + s.recv(1024).decode('utf-8')

    print ("Received:", resp)

    s.close()
